#pragma once

#include "Vector3.h"

typedef unsigned int uint;

// Simulation parameters
typedef struct {    
    Vector3 gravity;
    float particleRadius;
	float particleMass;
	float boundaryDamping;
	float globalDamping;

	float smoothingLength;
	float viscosity;

	Vector3 worldOrigin;
	Vector3 worldSize;
	float cellSize;

	Vector3 gridSize;
	int numGridCells;

	float mu0;
	float rho0;
	float kv;
	float stiffness;
	float dv;
} simParams_t;
