#pragma once

#define __NO_STD_VECTOR // Use cl::vector instead of STL version
#define __CL_ENABLE_EXCEPTIONS

#include "SnowAvalancheSim.h"

class clAdmin
{
public:
	clAdmin(void);
	~clAdmin(void);

	void startup();
	void shutdown();

	const cl::Platform & getPlatform() const { return m_clPlatform; }
	const cl::Context & getContext() const { return m_clContext; }
	const cl::CommandQueue & getCommandQueue() const { return m_clCommandQueue; }
	const cl::vector<cl::Device> & getDevices() const { return m_clDevices; }

private:
	cl::Platform m_clPlatform;
	cl::Context m_clContext;
	cl::CommandQueue m_clCommandQueue;
	cl::vector<cl::Device> m_clDevices;
};

extern clAdmin* g_clAdmin;