#pragma once

#define __NO_STD_VECTOR // Use cl::vector instead of STL version
#define __CL_ENABLE_EXCEPTIONS

#include "SystemTypes.h"
#include "SnowAvalancheSim.h"
#include "clAdmin.h"
#include "Vector4.h"
#include "clParticles.h"

class clSort
{
public:
	clSort(const char* fileName);
	~clSort(void);

	void init();
	void close();

	void createProgram();

	void bitonicSort(cl::Buffer m_dstKey, cl::Buffer m_dstVal, cl::Buffer m_srcKey, cl::Buffer m_srcVal);

private:
	cl::Program m_clSortProgram;

	cl::Kernel kBitonicSortLocal;
    cl::Kernel kBitonicSortLocal1;
    cl::Kernel kBitonicMergeGlobal;
    cl::Kernel kBitonicMergeLocal;

	const char* m_fileName;
};
